use std::{collections::HashSet, rc::Rc};

use crate::prelude::*;

pub struct VChannel {
    
}

struct VChannelService<Tag: 'static> {
    _ghost: std::marker::PhantomData<Tag>,
}

impl<Tag: 'static> Default for VChannelService<Tag> {
    fn default() -> Self {
        Self {
            _ghost: Default::default(),
        }
    }
}

impl<Tag: 'static> Service for Rc<VChannelService<Tag>> {
    fn register_channels(&self, eroot: &mut EventRoot) {
        
    }
}

#[derive(Default)]
pub struct VChannelDispatch {
    vchannels: HashSet<Rc<VChannel>>,
}

impl Service for std::rc::Rc<VChannelDispatch> {
    fn register_channels(&self, eroot: &mut EventRoot) {
        
    }
}

impl VChannelDispatch {
    pub fn link_udp_channel<SourceTag: 'static, SinkTag: 'static>(&self, api: &crate::Fleck) {
        api.add_service::<VChannelService<(SourceTag, SinkTag)>>();
    }

    fn stream_receive(&self, api: &crate::Fleck, data: Vec<u8>) -> Option<Vec<u8>> {
        None
    }

    fn udp_receive(&self, api: &crate::Fleck, data: (std::net::SocketAddr, Vec<u8>)) -> Option<(std::net::SocketAddr, Vec<u8>)> {
        None
    }
}
